// Made with Blockbench 4.12.4
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modelcircuit<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "circuit"), "main");
	private final ModelPart bone7;
	private final ModelPart bone5;
	private final ModelPart bone6;
	private final ModelPart bone;
	private final ModelPart bone3;
	private final ModelPart bone2;
	private final ModelPart bone4;

	public Modelcircuit(ModelPart root) {
		this.bone7 = root.getChild("bone7");
		this.bone5 = this.bone7.getChild("bone5");
		this.bone6 = this.bone7.getChild("bone6");
		this.bone = this.bone7.getChild("bone");
		this.bone3 = this.bone.getChild("bone3");
		this.bone2 = this.bone.getChild("bone2");
		this.bone4 = this.bone.getChild("bone4");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition bone7 = partdefinition.addOrReplaceChild("bone7", CubeListBuilder.create(),
				PartPose.offset(0.0F, 24.0F, 0.0F));

		PartDefinition bone5 = bone7.addOrReplaceChild("bone5", CubeListBuilder.create().texOffs(54, 0).addBox(-3.0F,
				0.0F, 0.0F, 7.0F, 40.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offset(3.0F, -40.0F, -1.0F));

		PartDefinition bone6 = bone7.addOrReplaceChild("bone6", CubeListBuilder.create().texOffs(40, 0).addBox(-4.0F,
				0.0F, 0.0F, 7.0F, 40.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offset(-3.0F, -40.0F, -1.0F));

		PartDefinition bone = bone7.addOrReplaceChild("bone",
				CubeListBuilder.create().texOffs(54, 40)
						.addBox(0.0F, -40.0F, 0.0F, 7.0F, 40.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(40, 40)
						.addBox(-7.0F, -40.0F, 0.2F, 7.0F, 40.0F, 0.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -40.0F, -1.0F));

		PartDefinition bone3 = bone.addOrReplaceChild("bone3", CubeListBuilder.create().texOffs(0, 0).addBox(0.0F,
				-2.0F, -0.2F, 10.0F, 57.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offset(7.0F, -38.0F, 0.0F));

		PartDefinition bone2 = bone.addOrReplaceChild("bone2", CubeListBuilder.create().texOffs(20, 0).addBox(-10.0F,
				-2.5F, 0.0F, 10.0F, 57.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offset(-7.0F, -37.5F, 0.0F));

		PartDefinition bone4 = bone.addOrReplaceChild("bone4",
				CubeListBuilder.create().texOffs(0, 61).addBox(-6.3751F, -14.2376F, 0.0F, 14.0F, 14.0F, 0.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-0.6505F, -39.846F, 0.0F, 0.0F, 0.0F, 0.1309F));

		PartDefinition bone4_r1 = bone4.addOrReplaceChild("bone4_r1",
				CubeListBuilder.create().texOffs(0, 61).addBox(-7.0F, -5.0F, 0.0F, 14.0F, 14.0F, 0.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.6249F, -19.2376F, 0.0F, 0.0F, 0.0F, -3.1416F));

		return LayerDefinition.create(meshdefinition, 128, 128);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		bone7.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
		this.bone3.xRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
		this.bone2.xRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
		this.bone5.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.bone4.yRot = netHeadYaw / (180F / (float) Math.PI);
		this.bone4.xRot = headPitch / (180F / (float) Math.PI);
		this.bone6.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
	}
}