package net.mcreator.thefixedscript.client.model;

import net.minecraft.util.Mth;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.state.LivingEntityRenderState;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

// Made with Blockbench 4.12.4
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports
public class Modelunknown extends EntityModel<LivingEntityRenderState> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(ResourceLocation.fromNamespaceAndPath("the_fixed_script", "modelunknown"), "main");
	public final ModelPart bone3;
	public final ModelPart bone5;
	public final ModelPart bone6;
	public final ModelPart bone4;
	public final ModelPart bone;
	public final ModelPart bone2;

	public Modelunknown(ModelPart root) {
		super(root);
		this.bone3 = root.getChild("bone3");
		this.bone5 = root.getChild("bone5");
		this.bone6 = this.bone5.getChild("bone6");
		this.bone4 = this.bone5.getChild("bone4");
		this.bone = this.bone5.getChild("bone");
		this.bone2 = root.getChild("bone2");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition bone3 = partdefinition.addOrReplaceChild("bone3", CubeListBuilder.create().texOffs(120, 177).addBox(-14.0F, 0.0F, 0.0F, 14.0F, 73.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offset(0.0F, -49.0F, -1.0F));
		PartDefinition bone5 = partdefinition.addOrReplaceChild("bone5",
				CubeListBuilder.create().texOffs(204, 177).addBox(0.0F, -73.0F, 0.0F, 14.0F, 73.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(148, 177).addBox(-14.0F, -73.0F, 0.0F, 14.0F, 73.0F, 0.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -49.0F, -1.0F));
		PartDefinition bone6 = bone5.addOrReplaceChild("bone6", CubeListBuilder.create().texOffs(40, 177).addBox(-20.0F, -5.0F, 0.0F, 20.0F, 98.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offset(-14.0F, -68.0F, 0.0F));
		PartDefinition bone4 = bone5.addOrReplaceChild("bone4", CubeListBuilder.create().texOffs(0, 177).addBox(0.0F, -5.0F, 0.0F, 20.0F, 98.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offset(14.0F, -68.0F, 0.0F));
		PartDefinition bone = bone5.addOrReplaceChild("bone", CubeListBuilder.create().texOffs(0, 0).addBox(-85.5F, -115.5F, 0.0F, 177.0F, 177.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offset(-0.5F, -72.5F, 1.0F));
		PartDefinition bone2 = partdefinition.addOrReplaceChild("bone2", CubeListBuilder.create().texOffs(176, 177).addBox(-1.0F, 0.0F, 0.0F, 14.0F, 73.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offset(1.0F, -49.0F, -1.0F));
		return LayerDefinition.create(meshdefinition, 512, 512);
	}

	public void setupAnim(LivingEntityRenderState state) {
		float limbSwing = state.walkAnimationPos;
		float limbSwingAmount = state.walkAnimationSpeed;
		float ageInTicks = state.ageInTicks;
		float netHeadYaw = state.yRot;
		float headPitch = state.xRot;

		this.bone3.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.bone2.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
		this.bone4.xRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
		this.bone.yRot = netHeadYaw / (180F / (float) Math.PI);
		this.bone.xRot = headPitch / (180F / (float) Math.PI);
		this.bone6.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
	}
}
