
package net.mcreator.thefixedscript.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.state.VillagerRenderState;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.model.geom.ModelLayers;
import net.minecraft.client.model.VillagerModel;

import net.mcreator.thefixedscript.entity.CircuitAsVillagerEntity;

import com.mojang.blaze3d.vertex.PoseStack;

public class CircuitAsVillagerRenderer extends MobRenderer<CircuitAsVillagerEntity, VillagerRenderState, VillagerModel> {
	private CircuitAsVillagerEntity entity = null;

	public CircuitAsVillagerRenderer(EntityRendererProvider.Context context) {
		super(context, new VillagerModel(context.bakeLayer(ModelLayers.VILLAGER)), 0.5f);
	}

	@Override
	public VillagerRenderState createRenderState() {
		return new VillagerRenderState();
	}

	@Override
	public void extractRenderState(CircuitAsVillagerEntity entity, VillagerRenderState state, float partialTicks) {
		super.extractRenderState(entity, state, partialTicks);
		this.entity = entity;
	}

	@Override
	public ResourceLocation getTextureLocation(VillagerRenderState state) {
		return ResourceLocation.parse("the_fixed_script:textures/entities/2025_04_21_03z_kleki.png");
	}

	@Override
	protected void scale(VillagerRenderState state, PoseStack poseStack) {
		poseStack.scale(0.9375f, 0.9375f, 0.9375f);
	}
}
