
package net.mcreator.thefixedscript.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.state.LivingEntityRenderState;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;

import net.mcreator.thefixedscript.entity.R2Entity;
import net.mcreator.thefixedscript.client.model.Modelr2;

public class R2Renderer extends MobRenderer<R2Entity, LivingEntityRenderState, Modelr2> {
	private R2Entity entity = null;

	public R2Renderer(EntityRendererProvider.Context context) {
		super(context, new Modelr2(context.bakeLayer(Modelr2.LAYER_LOCATION)), 0.5f);
	}

	@Override
	public LivingEntityRenderState createRenderState() {
		return new LivingEntityRenderState();
	}

	@Override
	public void extractRenderState(R2Entity entity, LivingEntityRenderState state, float partialTicks) {
		super.extractRenderState(entity, state, partialTicks);
		this.entity = entity;
	}

	@Override
	public ResourceLocation getTextureLocation(LivingEntityRenderState state) {
		return ResourceLocation.parse("the_fixed_script:textures/entities/error5.png");
	}
}
