// Made with Blockbench 4.12.4
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modelnotexture<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "notexture"), "main");
	private final ModelPart Body;
	private final ModelPart Head;
	private final ModelPart RightArm;
	private final ModelPart LeftArm;
	private final ModelPart RightLeg;
	private final ModelPart LeftLeg;

	public Modelnotexture(ModelPart root) {
		this.Body = root.getChild("Body");
		this.Head = this.Body.getChild("Head");
		this.RightArm = this.Body.getChild("RightArm");
		this.LeftArm = this.Body.getChild("LeftArm");
		this.RightLeg = root.getChild("RightLeg");
		this.LeftLeg = root.getChild("LeftLeg");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition Body = partdefinition.addOrReplaceChild("Body", CubeListBuilder.create().texOffs(0, 0)
				.addBox(-4.0F, -12.0F, -2.0F, 8.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 12.0F, 0.0F));

		PartDefinition Head = Body.addOrReplaceChild("Head",
				CubeListBuilder.create().texOffs(0, 16)
						.addBox(-4.0F, -7.0F, -4.0F, 4.0F, 7.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(38, 16)
						.addBox(-3.0F, -8.0F, -3.0F, 4.0F, 1.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(32, 32)
						.addBox(0.0F, -4.0F, 0.0F, 4.0F, 4.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -12.0F, 0.0F, 0.0F, 0.0F, -0.2182F));

		PartDefinition Head_r1 = Head.addOrReplaceChild("Head_r1",
				CubeListBuilder.create().texOffs(40, 0).addBox(-1.1F, -7.0F, -1.1F, 2.2F, 5.0F, 2.2F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-1.8F, -9.9F, -1.0F, 0.0F, 0.0F, 1.2654F));

		PartDefinition Head_r2 = Head.addOrReplaceChild("Head_r2",
				CubeListBuilder.create().texOffs(40, 7).addBox(-1.7199F, -0.8074F, -1.0F, 2.0F, 5.1F, 2.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(6.8598F, -15.3187F, -1.0F, -3.1416F, 0.0F, -2.3998F));

		PartDefinition Head_r3 = Head.addOrReplaceChild("Head_r3",
				CubeListBuilder.create().texOffs(32, 40).addBox(-1.9722F, -4.1716F, -1.1F, 2.2F, 5.0F, 2.2F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(6.8598F, -15.3187F, -1.0F, 3.1416F, 0.0F, 3.0107F));

		PartDefinition Head_r4 = Head.addOrReplaceChild("Head_r4",
				CubeListBuilder.create().texOffs(48, 6).addBox(-2.6301F, 2.7873F, -0.5F, 1.0F, 5.1F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(7.7001F, -14.2088F, -6.5F, 0.744F, 0.4073F, 1.0335F));

		PartDefinition Head_r5 = Head.addOrReplaceChild("Head_r5",
				CubeListBuilder.create().texOffs(16, 48).addBox(0.448F, -1.0602F, -0.6F, 1.2F, 5.0F, 1.2F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(7.7001F, -14.2088F, -6.5F, 0.8054F, -0.2236F, 1.6498F));

		PartDefinition Head_r6 = Head.addOrReplaceChild("Head_r6",
				CubeListBuilder.create().texOffs(20, 48).addBox(-1.9374F, -5.1917F, -0.5F, 1.0F, 5.1F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(7.7001F, -14.2088F, -6.5F, 2.3245F, -0.1603F, -1.8504F));

		PartDefinition Head_r7 = Head.addOrReplaceChild("Head_r7",
				CubeListBuilder.create().texOffs(24, 48).addBox(-5.1133F, -6.0572F, -0.6F, 1.2F, 5.0F, 1.2F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(7.7001F, -14.2088F, -6.5F, 2.6748F, -0.7128F, -2.616F));

		PartDefinition Head_r8 = Head.addOrReplaceChild("Head_r8",
				CubeListBuilder.create().texOffs(44, 46).addBox(-2.6301F, 2.7873F, -0.5F, 1.0F, 5.1F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(5.7001F, -23.2088F, -6.5F, 0.744F, 0.4073F, -0.4064F));

		PartDefinition Head_r9 = Head.addOrReplaceChild("Head_r9",
				CubeListBuilder.create().texOffs(32, 47).addBox(0.448F, -1.0602F, -0.6F, 1.2F, 5.0F, 1.2F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(5.7001F, -23.2088F, -6.5F, 0.8054F, -0.2236F, 0.2099F));

		PartDefinition Head_r10 = Head.addOrReplaceChild("Head_r10",
				CubeListBuilder.create().texOffs(36, 47).addBox(-1.9374F, -5.1917F, -0.5F, 1.0F, 5.1F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(5.7001F, -23.2088F, -6.5F, 2.3245F, -0.1603F, 2.9929F));

		PartDefinition Head_r11 = Head.addOrReplaceChild("Head_r11",
				CubeListBuilder.create().texOffs(48, 0).addBox(-5.1133F, -6.0572F, -0.6F, 1.2F, 5.0F, 1.2F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(5.7001F, -23.2088F, -6.5F, 2.6748F, -0.7128F, 2.2273F));

		PartDefinition Head_r12 = Head.addOrReplaceChild("Head_r12",
				CubeListBuilder.create().texOffs(8, 46).addBox(-2.6301F, 2.7873F, -0.5F, 1.0F, 5.1F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-3.2999F, -7.2087F, -8.5F, 0.744F, 0.4073F, -0.4064F));

		PartDefinition Head_r13 = Head.addOrReplaceChild("Head_r13",
				CubeListBuilder.create().texOffs(12, 46).addBox(0.448F, -1.0602F, -0.6F, 1.2F, 5.0F, 1.2F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-3.2999F, -7.2087F, -8.5F, 0.8054F, -0.2236F, 0.2099F));

		PartDefinition Head_r14 = Head.addOrReplaceChild("Head_r14",
				CubeListBuilder.create().texOffs(46, 22).addBox(-1.9374F, -5.1917F, -0.5F, 1.0F, 5.1F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-3.2999F, -7.2087F, -8.5F, 2.3245F, -0.1603F, 2.9929F));

		PartDefinition Head_r15 = Head.addOrReplaceChild("Head_r15",
				CubeListBuilder.create().texOffs(40, 46).addBox(-5.1133F, -6.0572F, -0.6F, 1.2F, 5.0F, 1.2F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-3.2999F, -7.2087F, -8.5F, 2.6748F, -0.7128F, 2.2273F));

		PartDefinition Head_r16 = Head.addOrReplaceChild("Head_r16",
				CubeListBuilder.create().texOffs(40, 40).addBox(-2.6301F, 2.7873F, -0.5F, 1.0F, 5.1F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-5.2999F, -12.2088F, -0.5F, 0.0F, 0.0F, -0.5672F));

		PartDefinition Head_r17 = Head.addOrReplaceChild("Head_r17",
				CubeListBuilder.create().texOffs(44, 40).addBox(0.448F, -1.0602F, -0.6F, 1.2F, 5.0F, 1.2F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-5.2999F, -12.2088F, -0.5F, 0.0F, 0.0F, 0.3054F));

		PartDefinition Head_r18 = Head.addOrReplaceChild("Head_r18",
				CubeListBuilder.create().texOffs(0, 46).addBox(-1.9374F, -5.1917F, -0.5F, 1.0F, 5.1F, 1.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-5.2999F, -12.2088F, -0.5F, -3.1416F, 0.0F, 2.9234F));

		PartDefinition Head_r19 = Head.addOrReplaceChild("Head_r19",
				CubeListBuilder.create().texOffs(4, 46).addBox(-5.1133F, -6.0572F, -0.6F, 1.2F, 5.0F, 1.2F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-5.2999F, -12.2088F, -0.5F, 3.1416F, 0.0F, 2.0508F));

		PartDefinition Head_r20 = Head.addOrReplaceChild("Head_r20",
				CubeListBuilder.create().texOffs(38, 22).addBox(-1.0F, -2.1F, -1.0F, 2.0F, 5.1F, 2.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -9.0F, -1.0F, 0.0F, 0.0F, 0.3927F));

		PartDefinition RightArm = Body.addOrReplaceChild("RightArm", CubeListBuilder.create().texOffs(22, 16)
				.addBox(-3.0F, -2.0F, -2.0F, 4.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-5.0F, -10.0F, 0.0F));

		PartDefinition LeftArm = Body.addOrReplaceChild("LeftArm", CubeListBuilder.create().texOffs(24, 0).addBox(-1.0F,
				-2.0F, -2.0F, 4.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)), PartPose.offset(5.0F, -10.0F, 0.0F));

		PartDefinition RightLeg = partdefinition.addOrReplaceChild("RightLeg", CubeListBuilder.create().texOffs(0, 30)
				.addBox(-2.0F, 0.0F, -2.0F, 4.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-1.9F, 12.0F, 0.0F));

		PartDefinition LeftLeg = partdefinition.addOrReplaceChild("LeftLeg", CubeListBuilder.create().texOffs(16, 32)
				.addBox(-2.0F, 0.0F, -2.0F, 4.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(1.9F, 12.0F, 0.0F));

		return LayerDefinition.create(meshdefinition, 64, 64);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		Body.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		RightLeg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		LeftLeg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
		this.RightArm.xRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
		this.LeftLeg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.Head.yRot = netHeadYaw / (180F / (float) Math.PI);
		this.Head.xRot = headPitch / (180F / (float) Math.PI);
		this.LeftArm.xRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
		this.RightLeg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
	}
}