
package net.mcreator.thefixedscript.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.state.LivingEntityRenderState;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;

import net.mcreator.thefixedscript.entity.FollowEntity;
import net.mcreator.thefixedscript.client.model.Modelnotexture;

public class FollowRenderer extends MobRenderer<FollowEntity, LivingEntityRenderState, Modelnotexture> {
	private FollowEntity entity = null;

	public FollowRenderer(EntityRendererProvider.Context context) {
		super(context, new Modelnotexture(context.bakeLayer(Modelnotexture.LAYER_LOCATION)), 0.5f);
	}

	@Override
	public LivingEntityRenderState createRenderState() {
		return new LivingEntityRenderState();
	}

	@Override
	public void extractRenderState(FollowEntity entity, LivingEntityRenderState state, float partialTicks) {
		super.extractRenderState(entity, state, partialTicks);
		this.entity = entity;
	}

	@Override
	public ResourceLocation getTextureLocation(LivingEntityRenderState state) {
		return ResourceLocation.parse("the_fixed_script:textures/entities/notexture.png");
	}
}
