
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.thefixedscript.init;

import net.neoforged.neoforge.registries.DeferredRegister;
import net.neoforged.neoforge.registries.DeferredHolder;
import net.neoforged.neoforge.event.entity.RegisterSpawnPlacementsEvent;
import net.neoforged.neoforge.event.entity.EntityAttributeCreationEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.resources.ResourceKey;
import net.minecraft.core.registries.Registries;

import net.mcreator.thefixedscript.entity.Xxram2diexXEntity;
import net.mcreator.thefixedscript.entity.TheBrokenEndEntity;
import net.mcreator.thefixedscript.entity.SubAnomaly1Entity;
import net.mcreator.thefixedscript.entity.R2Entity;
import net.mcreator.thefixedscript.entity.NulllEntity;
import net.mcreator.thefixedscript.entity.HimEntity;
import net.mcreator.thefixedscript.entity.FollowEntity;
import net.mcreator.thefixedscript.entity.CircuitEntity;
import net.mcreator.thefixedscript.entity.CircuitAsVillagerEntity;
import net.mcreator.thefixedscript.TheFixedScriptMod;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD)
public class TheFixedScriptModEntities {
	public static final DeferredRegister<EntityType<?>> REGISTRY = DeferredRegister.create(Registries.ENTITY_TYPE, TheFixedScriptMod.MODID);
	public static final DeferredHolder<EntityType<?>, EntityType<NulllEntity>> NULLL = register("nulll",
			EntityType.Builder.<NulllEntity>of(NulllEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).fireImmune().sized(0.6f, 1.8f));
	public static final DeferredHolder<EntityType<?>, EntityType<Xxram2diexXEntity>> XXRAM_2DIEX_X = register("xxram_2diex_x",
			EntityType.Builder.<Xxram2diexXEntity>of(Xxram2diexXEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3)

					.sized(0.6f, 1.8f));
	public static final DeferredHolder<EntityType<?>, EntityType<FollowEntity>> FOLLOW = register("follow",
			EntityType.Builder.<FollowEntity>of(FollowEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3)

					.sized(0.6f, 1.8f));
	public static final DeferredHolder<EntityType<?>, EntityType<CircuitEntity>> CIRCUIT = register("circuit",
			EntityType.Builder.<CircuitEntity>of(CircuitEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).fireImmune().sized(0.6f, 1.8f));
	public static final DeferredHolder<EntityType<?>, EntityType<R2Entity>> R_2 = register("r_2",
			EntityType.Builder.<R2Entity>of(R2Entity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).fireImmune().sized(0.6f, 1.8f));
	public static final DeferredHolder<EntityType<?>, EntityType<TheBrokenEndEntity>> THE_BROKEN_END = register("the_broken_end",
			EntityType.Builder.<TheBrokenEndEntity>of(TheBrokenEndEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).fireImmune().sized(0.6f, 1.8f));
	public static final DeferredHolder<EntityType<?>, EntityType<CircuitAsVillagerEntity>> CIRCUIT_AS_VILLAGER = register("circuit_as_villager",
			EntityType.Builder.<CircuitAsVillagerEntity>of(CircuitAsVillagerEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3)

					.sized(0.6f, 1.95f));
	public static final DeferredHolder<EntityType<?>, EntityType<HimEntity>> HIM = register("him",
			EntityType.Builder.<HimEntity>of(HimEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).fireImmune().sized(0.6f, 1.8f));
	public static final DeferredHolder<EntityType<?>, EntityType<SubAnomaly1Entity>> SUB_ANOMALY_1 = register("sub_anomaly_1",
			EntityType.Builder.<SubAnomaly1Entity>of(SubAnomaly1Entity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).fireImmune().sized(0.6f, 1.8f));

	// Start of user code block custom entities
	// End of user code block custom entities
	private static <T extends Entity> DeferredHolder<EntityType<?>, EntityType<T>> register(String registryname, EntityType.Builder<T> entityTypeBuilder) {
		return REGISTRY.register(registryname, () -> (EntityType<T>) entityTypeBuilder.build(ResourceKey.create(Registries.ENTITY_TYPE, ResourceLocation.fromNamespaceAndPath(TheFixedScriptMod.MODID, registryname))));
	}

	@SubscribeEvent
	public static void init(RegisterSpawnPlacementsEvent event) {
		NulllEntity.init(event);
		Xxram2diexXEntity.init(event);
		FollowEntity.init(event);
		CircuitEntity.init(event);
		R2Entity.init(event);
		TheBrokenEndEntity.init(event);
		CircuitAsVillagerEntity.init(event);
		HimEntity.init(event);
		SubAnomaly1Entity.init(event);
	}

	@SubscribeEvent
	public static void registerAttributes(EntityAttributeCreationEvent event) {
		event.put(NULLL.get(), NulllEntity.createAttributes().build());
		event.put(XXRAM_2DIEX_X.get(), Xxram2diexXEntity.createAttributes().build());
		event.put(FOLLOW.get(), FollowEntity.createAttributes().build());
		event.put(CIRCUIT.get(), CircuitEntity.createAttributes().build());
		event.put(R_2.get(), R2Entity.createAttributes().build());
		event.put(THE_BROKEN_END.get(), TheBrokenEndEntity.createAttributes().build());
		event.put(CIRCUIT_AS_VILLAGER.get(), CircuitAsVillagerEntity.createAttributes().build());
		event.put(HIM.get(), HimEntity.createAttributes().build());
		event.put(SUB_ANOMALY_1.get(), SubAnomaly1Entity.createAttributes().build());
	}
}
